#!/usr/bin/python

"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com, JJ Merelo (jj@merelo.net)

Visuse is free software: you can redistribute it and/or modify
it under 
the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""
# Modulo para wikimedia commons. Problema: busca solo el prefijo, no dentro de la cadena
import urllib
import urllib2
#import json                 # Python >2.6
import simplejson as json   # Python 2.5
from classes import *
import config
from difflib import SequenceMatcher




class Wikicommons(Result, ImageResult):
	def __init__(self, name, url, thumbnail):
		ImageResult.__init__(self, name, url, thumbnail)
		
	def estimateRating(self, search_terms):
		name_rating = SequenceMatcher(None, self.name, search_terms).real_quick_ratio()
		self.rating = self.rating + name_rating * 0.2
		self.rating = min(1, self.rating);





class SearchWikicommons(SearchModule):
	def __init__(self):
		SearchModule.__init__(self)

		
	def search(self, search_terms):
		query_string = "http://commons.wikimedia.org/w/api.php?action=query&format=json&list=allimages&aiprop=size|url|dimensions|mime&"
		response = urllib2.urlopen(query_string+urllib.urlencode({'aiprefix':search_terms}) )
		json_resultado= response.read()
		results = json.loads(json_resultado)
		
		for iterador in results['query']['allimages']:
				#~ print iterador, "\n"
				if iterador['mime'].find('image') >= 0:
					self.add(iterador)

		for n in range(0, len(self.resultList)):
			self.resultList[n].estimateRating(search_terms)

		return self.resultList
	

	def add(self, entry):
		self.resultList.append( 
			Wikicommons( entry['name'] ,
			 entry['url'],
			 entry['url']  ) )
		


#~ s = SearchWikicommons()
#~ s.search("molina")
#~ print unicode(s).encode("iso-8859-2", "replace")
